<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_TipoPrecio.xml */
/* Generado: 2020-08-18 04:21:28 */

/* Mantenimiento de los registros de la tabla MST_TipoPrecio */
abstract class BaseMST_TipoPrecioDP extends MST_TipoPrecioBV
{
    /* Constructor ( Establece los valores desde un objeto MST_TipoPrecioBN ) */
    public function __construct( MST_TipoPrecioBN $o_MST_TipoPrecioBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_TipoPrecioBN ) )
        {
            $this->setByBN( $o_MST_TipoPrecioBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_TipoPrecioBN */
    public function setByBN( MST_TipoPrecioBN $o_MST_TipoPrecioBN )
    {
        if ( !is_null( $o_MST_TipoPrecioBN->getIdTipoPrecio() ) )
        {
            $this->setIdTipoPrecio( $o_MST_TipoPrecioBN->getIdTipoPrecio() );
        }
        if ( !is_null( $o_MST_TipoPrecioBN->getNombre() ) )
        {
            $this->setNombre( $o_MST_TipoPrecioBN->getNombre() );
        }
        if ( !is_null( $o_MST_TipoPrecioBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_MST_TipoPrecioBN->getDescripcion() );
        }
        if ( !is_null( $o_MST_TipoPrecioBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_TipoPrecioBN->getEstado() );
        }
        if ( !is_null( $o_MST_TipoPrecioBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_TipoPrecioBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_TipoPrecioBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_TipoPrecioBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_TipoPrecioBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_TipoPrecioBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_TipoPrecioBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_TipoPrecioBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_TipoPrecioFN = new MST_TipoPrecioFN();
        $o_MST_TipoPrecioBN = $o_MST_TipoPrecioFN->selectByPk( $this->getIdTipoPrecio() );
        if ( is_null( $o_MST_TipoPrecioBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_TipoPrecio ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdTipoPrecio() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTipoPrecio";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdTipoPrecio()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombre() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Nombre";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Descripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_TipoPrecio SET ";
            $s_Separator = "";
            if ( !is_null( $this->getNombre() ) )
            {
                $s_SQLQuery .= $s_Separator."Nombre = '".$this->getNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."Descripcion = '".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdTipoPrecio = ".$this->getIdTipoPrecio().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_TipoPrecio WHERE  IdTipoPrecio = ".$this->getIdTipoPrecio().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>